com.genesyslab.wfm8.API.service.config810

## Interface WFMConfigService810Soap

-     public interface WFMConfigService810Soap

  The Configuration Service is one of many services provided by WFM Server. The purpose of this service is to provide unified and open-interface access to all Configuration and Policy data stored in the WFM database. All the Configuration, Staff, and Policy data from the WFM database is represented by a number of Configuration Objects. Every object represents some logical entity and stores corresponding information from one or more database tables.

- - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `closeSnapshot(java.lang.String snapshotID)` Closes configuration object snapshot
    `double` | `convertGMT2LocalTime(double GMTTime, int timezoneID)`
    `double` | `convertLocalTime(int timezoneID1, double localTime1, int timezoneID2)` Converts time in one time zone to another timezone
    `double` | `convertLocalTime2GMT(int timezoneID, double localTime)`
    `void` | `deleteCfgObject(int cfgObjectType, int siteID, int cfgObjectID)` Deletes a given Configuration Object
    `void` | `deleteCfgObjects(int cfgObjectType, int siteID, java.util.List<java.lang.Integer> cfgObjectIDArray)` Deletes multiple Configuration Objects
    `CfgActivityHolder` | `fetchActivityFromSnapshot(java.lang.String snapshotID, int firstIndex, int lastIndex, CfgActivityDetails details)` Retrieves range of Activity objects from existing Activity snapshot created with `openActivitySnapshot` method.
    `CfgAgentHolder` | `fetchAgentFromSnapshot(java.lang.String snapshotID, int firstIndex, int lastIndex, CfgAgentDetails details)` Retrieves a portion of Agent data from snapshot earlier created with `openAgentSnapshot` method.
    `CfgCarpoolHolder` | `fetchCarpoolFromSnapshot(java.lang.String snapshotID, int firstIndex, int lastIndex, CfgCarpoolDetails details)` Returns a range of Carpool objects from the snapshot
    `CfgContractHolder` | `fetchContractFromSnapshot(java.lang.String snapshotID, int firstIndex, int lastIndex, CfgContractDetails details)` Retrieves range of Contract objects from existing Contract snapshot created with `openContractSnapshot` method.
    `CfgMeetingHolder` | `fetchMeetingFromSnapshot(java.lang.String snapshotID, int firstIndex, int lastIndex, CfgMeetingDetails details)` Retrieves range of objects from Meeting snapshot
    `CfgProfileHolder` | `fetchProfileFromSnapshot(java.lang.String snapshotID, int firstIndex, int lastIndex, CfgProfileDetails details)` Retrieves range of Profile objects from existing Profile snapshot created with `openProfileSnapshot` method.
    `CfgReportHolder` | `fetchReportFromSnapshot(java.lang.String snapshotID, int firstIndex, int lastIndex, CfgReportDetails details)` Retrieves a portion of Report Task data from snapshot earlier created with `openReportSnapshot` method.
    `CfgReportTaskHolder` | `fetchReportTaskFromSnapshot(java.lang.String snapshotID, int firstIndex, int lastIndex, CfgReportTaskDetails details)` Retrieves a portion of Report Task data from snapshot earlier created with `openReportTaskSnapshot` method.
    `CfgRotationHolder` | `fetchRotationFromSnapshot(java.lang.String snapshotID, int firstIndex, int lastIndex, CfgRotationDetails details)` Retrieves a range of Rotating Pattern objects from snapshot
    `CfgShiftHolder` | `fetchShiftFromSnapshot(java.lang.String snapshotID, int firstIndex, int lastIndex, CfgShiftDetails details)` Retrieves range of objects from existing Shift snapshot
    `CfgTeamHolder` | `fetchTeamFromSnapshot(java.lang.String snapshotID, int firstIndex, int lastIndex, CfgTeamDetails details)` Retrieves range of Teams from existing Team snapshot created with `openTeamSnapshot` method.
    `int` | `findInSnapshot(java.lang.String snapshotID, int field, java.lang.String value, int startIndex)` Finds object in snapshot by specified field value
    `CfgAccrualRuleHolder` | `getAccrualRule(CfgAccrualRuleFilter accrualRuleFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode, CfgAccrualRuleDetails details)`
    `CfgActivityHolder` | `getActivity(CfgActivityFilter activityFilter, CfgAgentFilter agentFilter, CfgProfileFilter profileFilter, CfgSortMode sortMode, CfgActivityDetails details)` Retrieves Activity info (`CfgActivity` or `CfgActivityShort`) based on a given filter
    `CfgActivitySetHolder` | `getActivitySet(CfgActivitySetFilter activitySetFilter, CfgSortMode sortMode, CfgActivitySetDetails details)` Retrieves Activity Set objects
    `CfgAgentHolder` | `getAgent(CfgAgentFilter agentFilter, CfgActivityFilter activityFilter, CfgSortMode sortMode, CfgAgentDetails details)` Retrieves Agent info (`CfgAgent` or `CfgAgentShort`) based on provided filter `CfgAgentFilter`
    `java.util.List<CfgAgentState>` | `getAgentState(java.util.List<java.lang.Integer> agentStateIDArray, CfgSortMode sortMode)` Retrieves Genesys Agent States (`CfgAgentState`)
    `java.util.List<CfgAgentTeamHistory>` | `getAgentTeamHistory(CfgAgentFilter agentFilter, double startDateTime, double endDateTime, int timezoneID)` Returns Agent Team History
    `java.lang.String` | `getAuditLogAsync(CfgAuditFilter auditFilter, CfgSortMode sortMode)` Reads (async) Configuration Audit Log for specified filter
    `CfgAuditLog` | `getAuditLogResults(java.lang.String requestID)` Returns Audit Log for completed Async Request
    `CfgBreakHolder` | `getBreak(CfgBreakFilter breakFilter, CfgSortMode sortMode, CfgBreakDetails details)` Retrieves Break objects for given filter
    `CfgBUHolder` | `getBU(CfgBUFilter BUFilter, CfgSortMode sortMode, CfgBUDetails details)` Retrieves Business Unit information (`CfgBU` or `CfgBUShort`)
    `CfgCarpoolHolder` | `getCarpool(CfgCarpoolFilter carpoolFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode, CfgCarpoolDetails details)` Returns Carpool objects for specified filters
    `CfgColors` | `getColors()` Returns Colors
    `CfgContractHolder` | `getContract(CfgContractFilter contractFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode, CfgContractDetails details)` Retrieves Contracts (`CfgContract` or `CfgContractShort`) for a given filter
    `CfgExceptionTypeHolder` | `getExceptionType(CfgExceptionTypeFilter exceptionTypeFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode, CfgExceptionTypeDetails details)` Retrieves Exception Type objects for given filters
    `java.util.List<CfgFixedState>` | `getFixedState(java.util.List<java.lang.Integer> fixedStateIDArray, CfgSortMode sortMode)`
    `CfgGlobalSettings` | `getGlobalSettings()` Returns Global Settings
    `CfgMarkedTimeHolder` | `getMarkedTime(CfgMarkedTimeFilter markedTimeFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode, CfgMarkedTimeDetails details)` Retrieves Marked Time objects for given filter
    `CfgMealHolder` | `getMeal(CfgMealFilter mealFilter, CfgSortMode sortMode, CfgMealDetails details)` Retrieves Meal objects for given filter
    `CfgMeetingHolder` | `getMeeting(CfgMeetingFilter meetingFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode, CfgMeetingDetails details)` Retrieves Meeting objects for given filters
    `java.util.List<CfgNotifyParam>` | `getNotifyParam(int siteID, java.util.List<java.lang.Integer> notifyParamIDArray)` Returns `CfgNotifyParam` object(s)
    `java.util.List<CfgNotifyParam>` | `getNotifyParamBySubsystem(int siteID, java.util.List<java.lang.Integer> subsystemGroupIDArray)` Returns Notify Params by Subsystem
    `CfgPlanningPeriodHolder` | `getPlanningPeriod(int siteID, double startDate, double endDate)` Returns Planning Period information
    `CfgProfileHolder` | `getProfile(CfgProfileFilter profileFilter, CfgActivityFilter activityFilter, CfgSortMode sortMode, CfgProfileDetails details)` Retrieves Profiles (`CfgProfile` or `CfgProfileShort`) for a given filter
    `CfgReportHolder` | `getReport(CfgReportFilter filter, CfgSortMode sortMode, CfgReportDetails details)` Returns Report Task objects based on specified filter
    `CfgReportTaskHolder` | `getReportTask(CfgReportTaskFilter filter, CfgSortMode sortMode, CfgReportTaskDetails details)` Returns Report Task objects
    `CfgRotationHolder` | `getRotation(CfgRotationFilter rotationFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode, CfgRotationDetails details)` Retrieves Rotating Pattern information (`CfgRotation` or `CfgRotationShort`) for the given Site
    `CfgSecurityRoleHolder` | `getSecurityRole(java.util.List<java.lang.Integer> wmSecurityRoleId, CfgSortMode sortMode, CfgSecurityRoleDetails details)` Returns Security Roles
    `CfgShiftHolder` | `getShift(CfgShiftFilter shiftFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode, CfgShiftDetails details)` Retrieves Shift objects for given filters
    `CfgSiteHolder` | `getSite(CfgSiteFilter siteFilter, CfgSortMode sortMode, CfgSiteDetails details)` Retrieves Site info (`CfgSite` or `CfgSiteShort`)
    `java.util.List<CfgSkill>` | `getSkill(java.util.List<java.lang.Integer> skillIDArray, CfgSortMode sortMode)` Retrieves Skill information (`CfgSkill`)
    `CfgStateHolder` | `getState(CfgStateFilter stateFilter, CfgSortMode sortMode, CfgStateDetails details)`
    `CfgStateGroupHolder` | `getStateGroup(CfgStateGroupFilter stateGroupFilter, CfgSortMode sortMode, CfgStateGroupDetails details)`
    `java.util.List<CfgSubsystem>` | `getSubsystem(CfgSortMode sortMode)` Returns Subsystem objects
    `CfgTaskSequenceHolder` | `getTaskSequence(CfgTaskSequenceFilter taskSequenceFilter, CfgSortMode sortMode, CfgTaskSequenceDetails details)` Retrieves Task Sequence objects for given filter
    `CfgTeamHolder` | `getTeam(CfgTeamFilter teamFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode, CfgTeamDetails details)` Retrieves Team information (`CfgTeam` or `CfgTeamShort`) for a given filter.
    `java.util.List<CfgTeamHistory>` | `getTeamHistory(CfgTeamFilter teamFilter, double startDateTime, double endDateTime, int timezoneID)` Returns Team History
    `CfgTimeOffTypeHolder` | `getTimeOffType(CfgTimeOffTypeFilter timeOffTypeFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode, CfgTimeOffTypeDetails details)` Retrieves TimeOff Type objects for given filters
    `CfgTimezoneHolder` | `getTimezone(java.util.List<java.lang.Integer> timezoneIDArray, int sortMode, boolean ascending, int infoType)` Retrieves Time Zone information (`CfgTimezone` or `CfgTimezoneShort`)
    `CfgUserHolder` | `getUser(java.util.List<java.lang.Integer> userIDArray, int sortMode, boolean ascending, int infoType, boolean provideBUInfo, boolean provideSiteInfo, boolean provideTeamInfo, boolean provideSubsystemInfo)` Returns User information
    `CfgVirtualActivityHolder` | `getVirtualActivity(CfgVirtualActivityFilter virtualActivityFilter, CfgAgentFilter agentFilter, CfgProfileFilter profileFilter, CfgSortMode sortMode, CfgVirtualActivityDetails details)` Retrieves Virtual Activity objects for given filters
    `CfgValidationHolder` | `insertAccrualRule(CfgAccrualRule accrualRule, boolean ignoreWarnings)`
    `CfgValidationHolder` | `insertActivity(CfgActivity activity, boolean ignoreWarnings)` Inserts a new `CfgActivity` object into the database
    `CfgValidationHolder` | `insertActivitySet(CfgActivitySet activitySet, boolean ignoreWarnings)` Inserts `CfgActivitySet` object
    `CfgValidationHolder` | `insertAgent(CfgAgent agent, boolean ignoreWarnings)` Inserts new `CfgAgent` object
    `CfgValidationHolder` | `insertBreak(CfgBreak Break, boolean ignoreWarnings)` Inserts `CfgBreak` object
    `CfgValidationHolder` | `insertBU(CfgBU BU, boolean ignoreWarnings)` Inserts new CfgBU object
    `CfgValidationHolder` | `insertCarpool(CfgCarpool carpool, boolean ignoreWarnings)` Inserts new `CfgCarpool` object
    `CfgValidationHolder` | `insertContract(CfgContract contract, boolean ignoreWarnings)` Inserts new `CfgContract` object
    `CfgValidationHolder` | `insertExceptionType(CfgExceptionType exceptionType, boolean ignoreWarnings)` Inserts `CfgExceptionType` object
    `CfgValidationHolder` | `insertMarkedTime(CfgMarkedTime markedTime, boolean ignoreWarnings)` Inserts `CfgMarkedTime` object
    `CfgValidationHolder` | `insertMeal(CfgMeal meal, boolean ignoreWarnings)` Inserts `CfgMeal` object
    `CfgValidationHolder` | `insertMeeting(CfgMeeting meeting, boolean ignoreWarnings)` Inserts `CfgMeeting` object
    `CfgValidationHolder` | `insertNotifyParam(CfgNotifyParam notifyParam, boolean ignoreWarnings)` Inserts new `CfgNotifyParam` object into database
    `CfgValidationHolder` | `insertNotifyParams(java.util.List<CfgNotifyParam> notifyParams, boolean ignoreWarnings)` Inserts multiple `CfgNotifyParam` objects into database.
    `CfgValidationHolder` | `insertProfile(CfgProfile profile, boolean ignoreWarnings)` Inserts new `CfgProfile` object
    `CfgValidationHolder` | `insertReport(CfgReport report, boolean ignoreWarnings)` Inserts new `CfgReport` object.
    `CfgValidationHolder` | `insertReportTask(CfgReportTask reportTask, boolean ignoreWarnings)` Inserts new `CfgReportTask` object.
    `CfgValidationHolder` | `insertRotation(CfgRotation rotation, boolean ignoreWarnings)` Inserts Rotating Pattern
    `CfgValidationHolder` | `insertSecurityRole(CfgSecurityRole securityRole, boolean ignoreWarnings)` Inserts new Security Role
    `CfgValidationHolder` | `insertShift(CfgShift shift, boolean ignoreWarnings)` Inserts `CfgShift` object
    `CfgValidationHolder` | `insertSite(CfgSite site, boolean ignoreWarnings)` Inserts CfgSite object
    `CfgValidationHolder` | `insertSkill(CfgSkill skill, boolean ignoreWarnings)` Inserts `CfgSkill` object
    `CfgValidationHolder` | `insertState(CfgState state, boolean ignoreWarnings)`
    `CfgValidationHolder` | `insertStateGroup(CfgStateGroup stateGroup, boolean ignoreWarnings)`
    `CfgValidationHolder` | `insertTaskSequence(CfgTaskSequence taskSequence, boolean ignoreWarnings)` Inserts `CfgTaskSequence` object
    `CfgValidationHolder` | `insertTeam(CfgTeam team, boolean ignoreWarnings)` Inserts new `CfgTeam` object
    `CfgValidationHolder` | `insertTimeOffType(CfgTimeOffType timeOffType, boolean ignoreWarnings)` Inserts `CfgTimeOffType` object
    `CfgValidationHolder` | `insertTimezone(CfgTimezone timezone, boolean ignoreWarnings)` Inserts Time Zone
    `CfgValidationHolder` | `insertUser(CfgUser user, boolean ignoreWarnings)` Inserts User object
    `CfgValidationHolder` | `insertVirtualActivity(CfgVirtualActivity virtualActivity, boolean ignoreWarnings)` Inserts `CfgVirtualActivity` object
    `CfgSnapshot` | `openActivitySnapshot(CfgActivityFilter activityFilter, CfgAgentFilter agentFilter, CfgProfileFilter profileFilter, CfgSortMode sortMode)` Opens Activity snapshot based on given filters
    `CfgSnapshot` | `openAgentSnapshot(CfgAgentFilter agentFilter, CfgActivityFilter activityFilter, CfgSortMode sortMode)` Opens a snapshot of Agent info on server based on provided `CfgAgentFilter`, Retrieves Agent info (`CfgAgent` or `CfgAgentShort`) based on provided filter `CfgAgentFilter`
    `CfgSnapshot` | `openCarpoolSnapshot(CfgCarpoolFilter carpoolFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode)` Opens Carpool object snapshot for specified filters
    `CfgSnapshot` | `openContractSnapshot(CfgContractFilter contractFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode)` Opens Contract object snapshot based on a given filter
    `CfgSnapshot` | `openMeetingSnapshot(CfgMeetingFilter meetingFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode)` Opens Meeting object snapshot for given filters
    `CfgSnapshot` | `openProfileSnapshot(CfgProfileFilter profileFilter, CfgActivityFilter activityFilter, CfgSortMode sortMode)` Opens Profile object snapshot based on a given filter
    `CfgSnapshot` | `openReportSnapshot(CfgReportFilter filter, CfgSortMode sortMode)` Opens a snapshot of Report objects on server based on filter.
    `CfgSnapshot` | `openReportTaskSnapshot(CfgReportTaskFilter filter, CfgSortMode sortMode)` Opens a snapshot of Report Task info on server based on provided filter
    `CfgSnapshot` | `openRotationSnapshot(CfgRotationFilter rotationFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode)` Opens Rotating Pattern object snapshot for given filters
    `CfgSnapshot` | `openShiftSnapshot(CfgShiftFilter shiftFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode)` Opens Shift object snapshot for given filters
    `CfgSnapshot` | `openTeamSnapshot(CfgTeamFilter teamFilter, CfgAgentFilter agentFilter, CfgSortMode sortMode)` Opens Team info snapshot based on a given filter
    `long` | `readCfgObjectDBTimestamp(int cfgObjectType, int siteID, int cfgObjectID)` Returns the timestamp for when an object was last modified.
    `void` | `setColors(CfgColors colors)` Sets Colors
    `void` | `setGlobalSettings(CfgGlobalSettings settings)` Sets Global Settings
    `void` | `setLocalTimezone(CfgTimezone timezone)` Assigns Local Time Zone to current session
    `void` | `sortSnapshot(java.lang.String snapshotID, int sortMode, boolean ascending)` Sorts snapshot
    `CfgValidationHolder` | `updateAccrualRule(CfgAccrualRule accrualRule, boolean checkTimestamp, boolean ignoreWarnings)`
    `CfgValidationHolder` | `updateActivity(CfgActivity activity, boolean checkTimestamp, boolean ignoreWarnings)` Updates existing `CfgActivity` object
    `CfgValidationHolder` | `updateActivitySet(CfgActivitySet activitySet, boolean checkTimestamp, boolean ignoreWarnings)` Updates existing `CfgActivitySet` object
    `CfgValidationHolder` | `updateAgent(CfgAgent agent, boolean checkTimestamp, boolean ignoreWarnings)` Updates `CfgAgent` object
    `CfgValidationHolder` | `updateBreak(CfgBreak Break, boolean checkTimestamp, boolean ignoreWarnings)` Updates `CfgBreak` object
    `CfgValidationHolder` | `updateBU(CfgBU BU, boolean checkTimestamp, boolean ignoreWarnings)` Updates existing CfgBU object
    `CfgValidationHolder` | `updateCarpool(CfgCarpool carpool, boolean checkTimestamp, boolean ignoreWarnings)` Updates existing `CfgCarpool` object
    `CfgValidationHolder` | `updateContract(CfgContract contract, boolean checkTimestamp, boolean ignoreWarnings)` Updates new `CfgContract` object
    `CfgValidationHolder` | `updateExceptionType(CfgExceptionType exceptionType, boolean checkTimestamp, boolean ignoreWarnings)` Updates `CfgExceptionType` object
    `CfgValidationHolder` | `updateMarkedTime(CfgMarkedTime markedTime, boolean checkTimestamp, boolean ignoreWarnings)` Updates `CfgMarkedTime` object
    `CfgValidationHolder` | `updateMeal(CfgMeal meal, boolean checkTimestamp, boolean ignoreWarnings)` Updates existing `CfgMeal` object
    `CfgValidationHolder` | `updateMeeting(CfgMeeting meeting, boolean checkTimestamp, boolean ignoreWarnings)` Updates `CfgMeeting` object
    `CfgValidationHolder` | `updateNotifyParam(CfgNotifyParam notifyParam, boolean checkTimestamp, boolean ignoreWarnings)` Updates an existing `CfgNotifyParam` object in database
    `CfgValidationHolder` | `updateNotifyParams(java.util.List<CfgNotifyParam> notifyParams, boolean checkTimestamp, boolean ignoreWarnings)` Updates multiple `CfgNotifyParam` objects in the database.
    `CfgValidationHolder` | `updateProfile(CfgProfile profile, boolean checkTimestamp, boolean ignoreWarnings)` Updates existing `CfgProfile` object
    `CfgValidationHolder` | `updateReport(CfgReport report, boolean checkTimestamp, boolean ignoreWarnings)` Updates existing `CfgReport` object.
    `CfgValidationHolder` | `updateReportTask(CfgReportTask reportTask, boolean checkTimestamp, boolean ignoreWarnings)` Updates existing `CfgReportTask` object.
    `CfgValidationHolder` | `updateRotation(CfgRotation rotation, boolean checkTimestamp, boolean ignoreWarnings)` Updates Rotating Pattern
    `CfgValidationHolder` | `updateSecurityRole(CfgSecurityRole securityRole, boolean checkTimestamp, boolean ignoreWarnings)` Updates Security Role
    `CfgValidationHolder` | `updateShift(CfgShift shift, boolean checkTimestamp, boolean ignoreWarnings)` Updates `CfgShift` object
    `CfgValidationHolder` | `updateSite(CfgSite site, boolean checkTimestamp, boolean ignoreWarnings)` Update CfgSite object
    `CfgValidationHolder` | `updateSkill(CfgSkill skill, boolean checkTimestamp, boolean ignoreWarnings)` Updates `CfgSkill` object
    `CfgValidationHolder` | `updateState(CfgState state, boolean checkTimestamp, boolean ignoreWarnings)`
    `CfgValidationHolder` | `updateStateGroup(CfgStateGroup stateGroup, boolean checkTimestamp, boolean ignoreWarnings)`
    `CfgValidationHolder` | `updateTaskSequence(CfgTaskSequence taskSequence, boolean checkTimestamp, boolean ignoreWarnings)` Updates `CfgTaskSequence` object
    `CfgValidationHolder` | `updateTeam(CfgTeam team, boolean checkTimestamp, boolean ignoreWarnings)` Updates `CfgTeam` object
    `CfgValidationHolder` | `updateTimeOffType(CfgTimeOffType timeOffType, boolean checkTimestamp, boolean ignoreWarnings)` Updates `CfgTimeOffType` object
    `CfgValidationHolder` | `updateTimezone(CfgTimezone timezone, boolean checkTimestamp, boolean ignoreWarnings)` Updates Time Zone
    `CfgValidationHolder` | `updateUser(CfgUser user, boolean checkTimestamp, boolean ignoreWarnings)` Updates User object
    `CfgValidationHolder` | `updateVirtualActivity(CfgVirtualActivity virtualActivity, boolean checkTimestamp, boolean ignoreWarnings)` Updates `CfgVirtualActivity` object
    `CfgValidationHolder` | `validateAccrualRule(CfgAccrualRule accrualRule)`
    `CfgValidationHolder` | `validateActivity(CfgActivity activity)` Updates `CfgActivity` object
    `CfgValidationHolder` | `validateActivitySet(CfgActivitySet activitySet)` Validates `CfgActivitySet` object
    `CfgValidationHolder` | `validateAgent(CfgAgent agent)` Validates CfgAgent object
    `CfgValidationHolder` | `validateBreak(CfgBreak Break)` Validates `CfgBreak` object
    `CfgValidationHolder` | `validateBU(CfgBU BU)` Validates CfgBU object
    `CfgValidationHolder` | `validateCarpool(CfgCarpool carpool)` Validate `CfgCarpool` object
    `CfgValidationHolder` | `validateContract(CfgContract contract)` Validates `CfgContract` object
    `CfgValidationHolder` | `validateExceptionType(CfgExceptionType exceptionType)` Validates `CfgExceptionType` object
    `CfgValidationHolder` | `validateMarkedTime(CfgMarkedTime markedTime)` Validates `CfgMarkedTime` object
    `CfgValidationHolder` | `validateMeal(CfgMeal meal)` Validates `CfgMeal` object
    `CfgValidationHolder` | `validateMeeting(CfgMeeting meeting)` Validates `CfgMeeting` object
    `CfgValidationHolder` | `validateNotifyParam(CfgNotifyParam notifyParam)` Validates `CfgNotifyParam` object
    `CfgValidationHolder` | `validateProfile(CfgProfile profile)` Validate `CfgProfile` object
    `CfgValidationHolder` | `validateRotation(CfgRotation rotation)` Validates Rotating Pattern
    `CfgValidationHolder` | `validateShift(CfgShift shift)` Validates `CfgShift` object
    `CfgValidationHolder` | `validateSite(CfgSite site)` Validate CfgSite object
    `CfgValidationHolder` | `validateSkill(CfgSkill skill)` Validates `CfgSkill` object
    `CfgValidationHolder` | `validateState(CfgState state)`
    `CfgValidationHolder` | `validateStateGroup(CfgStateGroup stateGroup)`
    `CfgValidationHolder` | `validateTaskSequence(CfgTaskSequence taskSequence)` Validates `CfgTaskSequence` object
    `CfgValidationHolder` | `validateTeam(CfgTeam team)` Validate `CfgTeam` object
    `CfgValidationHolder` | `validateTimeOffType(CfgTimeOffType timeOffType)` Validates `CfgTimeOffType` object
    `CfgValidationHolder` | `validateTimezone(CfgTimezone timezone)` Validates Time Zone object
    `CfgValidationHolder` | `validateUser(CfgUser user)` Validates User object
    `CfgValidationHolder` | `validateVirtualActivity(CfgVirtualActivity virtualActivity)` Validates `CfgVirtualActivity` object

- - ### Method Detail

    - #### deleteCfgObject

          void deleteCfgObject(int cfgObjectType,
                             int siteID,
                             int cfgObjectID)

      Deletes a given Configuration Object
      Parameters:
        `cfgObjectType` - Object Type `ECfgObjectType`
        `siteID` - Site ID
        `cfgObjectID` - Object ID

    - #### deleteCfgObjects

          void deleteCfgObjects(int cfgObjectType,
                              int siteID,
                              java.util.List<java.lang.Integer> cfgObjectIDArray)

      Deletes multiple Configuration Objects
      Parameters:
        `cfgObjectType` - Object Type `ECfgObjectType`
        `siteID` - Site ID
        `cfgObjectIDArray` - Object ID Array

    - #### readCfgObjectDBTimestamp

          long readCfgObjectDBTimestamp(int cfgObjectType,
                                      int siteID,
                                      int cfgObjectID)

      Returns the timestamp for when an object was last modified. The timestamp value here can be compared to that of an earlier retrieved object to see if the object information is up to date.
      Parameters:
        `cfgObjectType` - Object Type `ECfgObjectType`
        `siteID` - Site ID
        `cfgObjectID` - Object ID
      Returns:
        Timestamp value

    - #### closeSnapshot

          void closeSnapshot(java.lang.String snapshotID)

      Closes configuration object snapshot
      Parameters:
        `snapshotID` - Snapshot ID

    - #### sortSnapshot

          void sortSnapshot(java.lang.String snapshotID,
                          int sortMode,
                          boolean ascending)

      Sorts snapshot
      Parameters:
        `sortMode` -
        `snapshotID` -
        `ascending` -

    - #### findInSnapshot

          int findInSnapshot(java.lang.String snapshotID,
                           int field,
                           java.lang.String value,
                           int startIndex)

      Finds object in snapshot by specified field value
      Parameters:
        `snapshotID` - Snapshot ID
        `field` - Field
        `value` - Value
        `startIndex` - Starting index
      Returns:
        returns an index of found object in snapshot. Returns -1 if not found.

    - #### insertBU

          CfgValidationHolder insertBU(CfgBU BU,
                                     boolean ignoreWarnings)

      Inserts new CfgBU object
      Parameters:
        `BU` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### updateBU

          CfgValidationHolder updateBU(CfgBU BU,
                                     boolean checkTimestamp,
                                     boolean ignoreWarnings)

      Updates existing CfgBU object
      Parameters:
        `BU` -
        `checkTimestamp` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### validateBU

          CfgValidationHolder validateBU(CfgBU BU)

      Validates CfgBU object
      Parameters:
        `BU` -
      Returns:
        returns `CfgValidationHolder`

    - #### getBU

          CfgBUHolder getBU(CfgBUFilter BUFilter,
                          CfgSortMode sortMode,
                          CfgBUDetails details)

      Retrieves Business Unit information (`CfgBU` or `CfgBUShort`)
      Parameters:
        `BUFilter` - Filter `CfgBUFilter`
        `sortMode` - BU sort mode `CfgSortMode`, `ECfgSortMode.BU`
        `details` - Requested details `CfgBUDetails`
      Returns:
        returns `CfgBUHolder`

    - #### insertSite

          CfgValidationHolder insertSite(CfgSite site,
                                       boolean ignoreWarnings)

      Inserts CfgSite object
      Parameters:
        `site` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### updateSite

          CfgValidationHolder updateSite(CfgSite site,
                                       boolean checkTimestamp,
                                       boolean ignoreWarnings)

      Update CfgSite object
      Parameters:
        `site` -
        `checkTimestamp` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### validateSite

          CfgValidationHolder validateSite(CfgSite site)

      Validate CfgSite object
      Parameters:
        `site` -
      Returns:
        returns `CfgValidationHolder`

    - #### getSite

          CfgSiteHolder getSite(CfgSiteFilter siteFilter,
                              CfgSortMode sortMode,
                              CfgSiteDetails details)

      Retrieves Site info (`CfgSite` or `CfgSiteShort`)
      Parameters:
        `siteFilter` - Filter `CfgSiteFilter`
        `sortMode` - Site sort mode `CfgSortMode`, `ECfgSortMode.Site`
        `details` - Requested details `CfgSiteDetails`
      Returns:
        returns `CfgSiteHolder`

    - #### insertAgent

          CfgValidationHolder insertAgent(CfgAgent agent,
                                        boolean ignoreWarnings)

      Inserts new `CfgAgent` object
      Parameters:
        `agent` - `CfgAgent` object to insert
        `ignoreWarnings` - Ignore warnings if any
      Returns:
        `CfgValidationHolder`

    - #### updateAgent

          CfgValidationHolder updateAgent(CfgAgent agent,
                                        boolean checkTimestamp,
                                        boolean ignoreWarnings)

      Updates `CfgAgent` object
      Parameters:
        `agent` - `CfgAgent` object to update
        `checkTimestamp` - Check timestamp to make sure that object wasn't modified by another user
        `ignoreWarnings` - Ignore warnings if any
      Returns:
        returns `CfgValidationHolder`

    - #### validateAgent

          CfgValidationHolder validateAgent(CfgAgent agent)

      Validates CfgAgent object
      Parameters:
        `agent` -
      Returns:
        returns `CfgValidationHolder`

    - #### getAgent

          CfgAgentHolder getAgent(CfgAgentFilter agentFilter,
                                CfgActivityFilter activityFilter,
                                CfgSortMode sortMode,
                                CfgAgentDetails details)

      Retrieves Agent info (`CfgAgent` or `CfgAgentShort`) based on provided filter `CfgAgentFilter`
      Parameters:
        `agentFilter` - Agent filter `CfgAgentFilter`
        `activityFilter` - Activity filter `CfgActivityFilter`
        `sortMode` - Agent sort mode `CfgSortMode`, `ECfgSortMode.Agent`
        `details` - Requested details `CfgAgentDetails`
      Returns:
        returns `CfgAgentHolder`

    - #### openAgentSnapshot

          CfgSnapshot openAgentSnapshot(CfgAgentFilter agentFilter,
                                      CfgActivityFilter activityFilter,
                                      CfgSortMode sortMode)

      Opens a snapshot of Agent info on server based on provided `CfgAgentFilter`, Retrieves Agent info (`CfgAgent` or `CfgAgentShort`) based on provided filter `CfgAgentFilter`
      Parameters:
        `agentFilter` - Agent filter `CfgAgentFilter`
        `activityFilter` - Activity filter `CfgActivityFilter`
        `sortMode` - Agent sort mode `CfgSortMode`, `ECfgSortMode.Agent`
      Returns:
        Returns `CfgSnapshot`

    - #### fetchAgentFromSnapshot

          CfgAgentHolder fetchAgentFromSnapshot(java.lang.String snapshotID,
                                              int firstIndex,
                                              int lastIndex,
                                              CfgAgentDetails details)

      Retrieves a portion of Agent data from snapshot earlier created with `openAgentSnapshot` method.
      Parameters:
        `snapshotID` - Agent Snapshot ID
        `firstIndex` - First Agent index
        `lastIndex` - Last Agent index
        `details` - Requested details `CfgAgentDetails`
      Returns:
        returns `CfgAgentHolder`

    - #### insertTeam

          CfgValidationHolder insertTeam(CfgTeam team,
                                       boolean ignoreWarnings)

      Inserts new `CfgTeam` object
      Parameters:
        `team` - `CfgTeam` object to insert
        `ignoreWarnings` - Ignore warnings if any
      Returns:
        returns `CfgValidationHolder`

    - #### updateTeam

          CfgValidationHolder updateTeam(CfgTeam team,
                                       boolean checkTimestamp,
                                       boolean ignoreWarnings)

      Updates `CfgTeam` object
      Parameters:
        `team` - `CfgTeam` object to update
        `checkTimestamp` - Check timestamp to make sure that object wasn't modified by another user
        `ignoreWarnings` - Ignore warnings if any
      Returns:
        returns `CfgValidationHolder`

    - #### validateTeam

          CfgValidationHolder validateTeam(CfgTeam team)

      Validate `CfgTeam` object
      Parameters:
        `team` - `CfgTeam` object
      Returns:
        returns `CfgValidationHolder`

    - #### getTeam

          CfgTeamHolder getTeam(CfgTeamFilter teamFilter,
                              CfgAgentFilter agentFilter,
                              CfgSortMode sortMode,
                              CfgTeamDetails details)

      Retrieves Team information (`CfgTeam` or `CfgTeamShort`) for a given filter.
      Parameters:
        `teamFilter` - Team filter `CfgTeamFilter`
        `agentFilter` - Agent filter `CfgAgentFilter`
        `sortMode` - Team sort mode `CfgSortMode`, `ECfgSortMode.Team`
        `details` - Requested details `CfgTeamDetails`
      Returns:
        returns `CfgTeamHolder`

    - #### openTeamSnapshot

          CfgSnapshot openTeamSnapshot(CfgTeamFilter teamFilter,
                                     CfgAgentFilter agentFilter,
                                     CfgSortMode sortMode)

      Opens Team info snapshot based on a given filter
      Parameters:
        `teamFilter` - Team filter `CfgTeamFilter`
        `agentFilter` - Agent filter `CfgAgentFilter`
        `sortMode` - Team sort mode `CfgSortMode`, `ECfgSortMode.Team`
      Returns:
        Returns `CfgSnapshot`

    - #### fetchTeamFromSnapshot

          CfgTeamHolder fetchTeamFromSnapshot(java.lang.String snapshotID,
                                            int firstIndex,
                                            int lastIndex,
                                            CfgTeamDetails details)

      Retrieves range of Teams from existing Team snapshot created with `openTeamSnapshot` method.
      Parameters:
        `snapshotID` - Team Snapshot ID
        `firstIndex` - First Team index
        `lastIndex` - Last Team index
        `details` - Requested details `CfgTeamDetails`
      Returns:
        returns `CfgTeamHolder`

    - #### insertContract

          CfgValidationHolder insertContract(CfgContract contract,
                                           boolean ignoreWarnings)

      Inserts new `CfgContract` object
      Parameters:
        `contract` - `CfgContract` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateContract

          CfgValidationHolder updateContract(CfgContract contract,
                                           boolean checkTimestamp,
                                           boolean ignoreWarnings)

      Updates new `CfgContract` object
      Parameters:
        `contract` - `CfgContract` object to update
        `checkTimestamp` - Check timestamp to make sure that object wasn't modified by another user
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateContract

          CfgValidationHolder validateContract(CfgContract contract)

      Validates `CfgContract` object
      Parameters:
        `contract` - `CfgContract` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getContract

          CfgContractHolder getContract(CfgContractFilter contractFilter,
                                      CfgAgentFilter agentFilter,
                                      CfgSortMode sortMode,
                                      CfgContractDetails details)

      Retrieves Contracts (`CfgContract` or `CfgContractShort`) for a given filter
      Parameters:
        `contractFilter` - Contract filter (`CfgContractFilter`
        `agentFilter` - Agent filter (`CfgAgentFilter`
        `sortMode` - Contract sort mode `CfgSortMode`, `ECfgSortMode.Contract`
        `details` - Requested details `CfgContractDetails`
      Returns:
        returns `CfgContractHolder`

    - #### openContractSnapshot

          CfgSnapshot openContractSnapshot(CfgContractFilter contractFilter,
                                         CfgAgentFilter agentFilter,
                                         CfgSortMode sortMode)

      Opens Contract object snapshot based on a given filter
      Parameters:
        `agentFilter` - Agent filter (`CfgAgentFilter`
        `sortMode` - Contract sort mode `CfgSortMode`, `ECfgSortMode.Contract`
        `contractFilter` - Contract filter (`CfgContractFilter`
      Returns:
        returns `CfgSnapshot`

    - #### fetchContractFromSnapshot

          CfgContractHolder fetchContractFromSnapshot(java.lang.String snapshotID,
                                                    int firstIndex,
                                                    int lastIndex,
                                                    CfgContractDetails details)

      Retrieves range of Contract objects from existing Contract snapshot created with `openContractSnapshot` method.
      Parameters:
        `snapshotID` - Contract Snapshot ID
        `firstIndex` - First Contract index
        `lastIndex` - Last Contract index
        `details` - Requested details `CfgContractDetails`
      Returns:
        returns `CfgContractHolder`

    - #### insertProfile

          CfgValidationHolder insertProfile(CfgProfile profile,
                                          boolean ignoreWarnings)

      Inserts new `CfgProfile` object
      Parameters:
        `profile` - `CfgProfile` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateProfile

          CfgValidationHolder updateProfile(CfgProfile profile,
                                          boolean checkTimestamp,
                                          boolean ignoreWarnings)

      Updates existing `CfgProfile` object
      Parameters:
        `profile` - `CfgProfile` object to update
        `checkTimestamp` - Check timestamp to make sure that object wasn't modified by another user
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateProfile

          CfgValidationHolder validateProfile(CfgProfile profile)

      Validate `CfgProfile` object
      Parameters:
        `profile` - `CfgProfile` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getProfile

          CfgProfileHolder getProfile(CfgProfileFilter profileFilter,
                                    CfgActivityFilter activityFilter,
                                    CfgSortMode sortMode,
                                    CfgProfileDetails details)

      Retrieves Profiles (`CfgProfile` or `CfgProfileShort`) for a given filter
      Parameters:
        `profileFilter` - Profile filter `CfgProfileFilter`
        `activityFilter` - Activity filter `CfgActivityFilter`
        `sortMode` - Profile sort mode `CfgSortMode`, `ECfgSortMode.Profile`
        `details` - Requested details `CfgProfileDetails`
      Returns:
        returns `CfgProfileHolder`

    - #### openProfileSnapshot

          CfgSnapshot openProfileSnapshot(CfgProfileFilter profileFilter,
                                        CfgActivityFilter activityFilter,
                                        CfgSortMode sortMode)

      Opens Profile object snapshot based on a given filter
      Parameters:
        `profileFilter` - Profile filter `CfgProfileFilter`
        `activityFilter` - Activity filter `CfgActivityFilter`
        `sortMode` - Profile sort mode `CfgSortMode`, `ECfgSortMode.Profile`
      Returns:
        returns `CfgSnapshot`

    - #### fetchProfileFromSnapshot

          CfgProfileHolder fetchProfileFromSnapshot(java.lang.String snapshotID,
                                                  int firstIndex,
                                                  int lastIndex,
                                                  CfgProfileDetails details)

      Retrieves range of Profile objects from existing Profile snapshot created with `openProfileSnapshot` method.
      Parameters:
        `snapshotID` - Profile Snapshot ID
        `firstIndex` - First Profile index
        `lastIndex` - Last Profile index
        `details` - Requested details `CfgProfileDetails`
      Returns:
        returns `CfgProfileHolder`

    - #### insertActivity

          CfgValidationHolder insertActivity(CfgActivity activity,
                                           boolean ignoreWarnings)

      Inserts a new `CfgActivity` object into the database
      Parameters:
        `activity` - `CfgActivity` object to insert
        `ignoreWarnings` - Ignore warnings, if any
      Returns:
        `CfgValidationHolder`

    - #### updateActivity

          CfgValidationHolder updateActivity(CfgActivity activity,
                                           boolean checkTimestamp,
                                           boolean ignoreWarnings)

      Updates existing `CfgActivity` object
      Parameters:
        `activity` - `CfgActivity` object to update
        `checkTimestamp` - Check timestamp (to ensure object has not been modified by another user).
        `ignoreWarnings` - Ignore warnings, if any
      Returns:
        returns `CfgValidationHolder`

    - #### validateActivity

          CfgValidationHolder validateActivity(CfgActivity activity)

      Updates `CfgActivity` object
      Parameters:
        `activity` - `CfgActivity` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getActivity

          CfgActivityHolder getActivity(CfgActivityFilter activityFilter,
                                      CfgAgentFilter agentFilter,
                                      CfgProfileFilter profileFilter,
                                      CfgSortMode sortMode,
                                      CfgActivityDetails details)

      Retrieves Activity info (`CfgActivity` or `CfgActivityShort`) based on a given filter
      Parameters:
        `activityFilter` - Activity filter `CfgActivityFilter`
        `agentFilter` - Agent filter `CfgAgentFilter` that is used to filter Activities based on Agent skills
        `profileFilter` - Profile filter `CfgProfileFilter` that is used to filter Activities based on Profile `CfgProfile` skills
        `sortMode` - Activity sort mode `CfgSortMode`, `ECfgSortMode.Activity`
        `details` - Requested details `CfgActivityDetails`
      Returns:
        returns `CfgActivityHolder`

    - #### openActivitySnapshot

          CfgSnapshot openActivitySnapshot(CfgActivityFilter activityFilter,
                                         CfgAgentFilter agentFilter,
                                         CfgProfileFilter profileFilter,
                                         CfgSortMode sortMode)

      Opens Activity snapshot based on given filters
      Parameters:
        `activityFilter` - Activity filter `CfgActivityFilter`
        `agentFilter` - Agent filter `CfgAgentFilter` that is used to filter Activities based on Agent skills
        `profileFilter` - Profile filter `CfgProfileFilter` that is used to filter Activities based on Profile `CfgProfile` skills
        `sortMode` - Activity sort mode `CfgSortMode`, `ECfgSortMode.Activity`
      Returns:
        returns `CfgSnapshot`

    - #### fetchActivityFromSnapshot

          CfgActivityHolder fetchActivityFromSnapshot(java.lang.String snapshotID,
                                                    int firstIndex,
                                                    int lastIndex,
                                                    CfgActivityDetails details)

      Retrieves range of Activity objects from existing Activity snapshot created with `openActivitySnapshot` method.
      Parameters:
        `snapshotID` - Activity snapshot ID
        `firstIndex` - First index
        `lastIndex` - Last index
        `details` - Requested details `CfgActivityDetails`
      Returns:
        returns `CfgActivityHolder`

    - #### insertActivitySet

          CfgValidationHolder insertActivitySet(CfgActivitySet activitySet,
                                              boolean ignoreWarnings)

      Inserts `CfgActivitySet` object
      Parameters:
        `activitySet` - `CfgActivitySet` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateActivitySet

          CfgValidationHolder updateActivitySet(CfgActivitySet activitySet,
                                              boolean checkTimestamp,
                                              boolean ignoreWarnings)

      Updates existing `CfgActivitySet` object
      Parameters:
        `activitySet` - `CfgActivitySet` object to update
        `checkTimestamp` - Check timestamp (to ensure object has not been modified by another user).
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateActivitySet

          CfgValidationHolder validateActivitySet(CfgActivitySet activitySet)

      Validates `CfgActivitySet` object
      Parameters:
        `activitySet` - `CfgActivitySet` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getActivitySet

          CfgActivitySetHolder getActivitySet(CfgActivitySetFilter activitySetFilter,
                                            CfgSortMode sortMode,
                                            CfgActivitySetDetails details)

      Retrieves Activity Set objects
      Parameters:
        `activitySetFilter` - Filter `CfgActivitySetFilter`
        `sortMode` - Activity Set sort mode `CfgSortMode`, `ECfgSortMode.ActivitySet`
        `details` - Requested details `CfgActivitySetDetails`
      Returns:
        returns `CfgActivitySetHolder`

    - #### insertVirtualActivity

          CfgValidationHolder insertVirtualActivity(CfgVirtualActivity virtualActivity,
                                                  boolean ignoreWarnings)

      Inserts `CfgVirtualActivity` object
      Parameters:
        `virtualActivity` - `CfgVirtualActivity` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateVirtualActivity

          CfgValidationHolder updateVirtualActivity(CfgVirtualActivity virtualActivity,
                                                  boolean checkTimestamp,
                                                  boolean ignoreWarnings)

      Updates `CfgVirtualActivity` object
      Parameters:
        `virtualActivity` - `CfgVirtualActivity` object to update
        `checkTimestamp` - Check timestamp (to ensure object has not been modified by another user).
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateVirtualActivity

          CfgValidationHolder validateVirtualActivity(CfgVirtualActivity virtualActivity)

      Validates `CfgVirtualActivity` object
      Parameters:
        `virtualActivity` - `CfgVirtualActivity` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getVirtualActivity

          CfgVirtualActivityHolder getVirtualActivity(CfgVirtualActivityFilter virtualActivityFilter,
                                                    CfgAgentFilter agentFilter,
                                                    CfgProfileFilter profileFilter,
                                                    CfgSortMode sortMode,
                                                    CfgVirtualActivityDetails details)

      Retrieves Virtual Activity objects for given filters
      Parameters:
        `virtualActivityFilter` - `CfgVirtualActivityFilter`
        `agentFilter` - `CfgAgentFilter`
        `profileFilter` - `CfgProfileFilter`
        `sortMode` - Sort mode `CfgSortMode`, `ECfgSortMode.VirtualActivity`
        `details` - Requested details `CfgActivitySetDetails`
      Returns:
        returns `CfgVirtualActivityHolder`

    - #### insertShift

          CfgValidationHolder insertShift(CfgShift shift,
                                        boolean ignoreWarnings)

      Inserts `CfgShift` object
      Parameters:
        `shift` - `CfgShift` object
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateShift

          CfgValidationHolder updateShift(CfgShift shift,
                                        boolean checkTimestamp,
                                        boolean ignoreWarnings)

      Updates `CfgShift` object
      Parameters:
        `shift` - `CfgShift` object
        `checkTimestamp` - Check timestamp (to ensure object has not been modified by another user).
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateShift

          CfgValidationHolder validateShift(CfgShift shift)

      Validates `CfgShift` object
      Parameters:
        `shift` - `CfgShift` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getShift

          CfgShiftHolder getShift(CfgShiftFilter shiftFilter,
                                CfgAgentFilter agentFilter,
                                CfgSortMode sortMode,
                                CfgShiftDetails details)

      Retrieves Shift objects for given filters
      Parameters:
        `shiftFilter` - `CfgShiftFilter`
        `agentFilter` - `CfgAgentFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.Shift`
        `details` - `CfgShiftDetails`
      Returns:
        returns `CfgShiftHolder`

    - #### openShiftSnapshot

          CfgSnapshot openShiftSnapshot(CfgShiftFilter shiftFilter,
                                      CfgAgentFilter agentFilter,
                                      CfgSortMode sortMode)

      Opens Shift object snapshot for given filters
      Parameters:
        `shiftFilter` - `CfgShiftFilter`
        `agentFilter` - `CfgAgentFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.Shift`
      Returns:
        returns `CfgSnapshot`

    - #### fetchShiftFromSnapshot

          CfgShiftHolder fetchShiftFromSnapshot(java.lang.String snapshotID,
                                              int firstIndex,
                                              int lastIndex,
                                              CfgShiftDetails details)

      Retrieves range of objects from existing Shift snapshot
      Parameters:
        `snapshotID` - Snapshot ID
        `firstIndex` - First index
        `lastIndex` - Last index
        `details` - `CfgShiftDetails`
      Returns:
        returns `CfgShiftHolder`

    - #### insertMeal

          CfgValidationHolder insertMeal(CfgMeal meal,
                                       boolean ignoreWarnings)

      Inserts `CfgMeal` object
      Parameters:
        `meal` - `CfgMeal` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateMeal

          CfgValidationHolder updateMeal(CfgMeal meal,
                                       boolean checkTimestamp,
                                       boolean ignoreWarnings)

      Updates existing `CfgMeal` object
      Parameters:
        `meal` - `CfgMeal` object to update
        `checkTimestamp` - Check timestamp (to ensure object has not been modified by another user).
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateMeal

          CfgValidationHolder validateMeal(CfgMeal meal)

      Validates `CfgMeal` object
      Parameters:
        `meal` - `CfgMeal` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getMeal

          CfgMealHolder getMeal(CfgMealFilter mealFilter,
                              CfgSortMode sortMode,
                              CfgMealDetails details)

      Retrieves Meal objects for given filter
      Parameters:
        `mealFilter` - `CfgMealFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.Meal`
        `details` - `CfgMealDetails`
      Returns:
        returns `CfgMealHolder`

    - #### insertBreak

          CfgValidationHolder insertBreak(CfgBreak Break,
                                        boolean ignoreWarnings)

      Inserts `CfgBreak` object
      Parameters:
        `Break` - `CfgBreak` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateBreak

          CfgValidationHolder updateBreak(CfgBreak Break,
                                        boolean checkTimestamp,
                                        boolean ignoreWarnings)

      Updates `CfgBreak` object
      Parameters:
        `Break` - `CfgBreak` object to update
        `checkTimestamp` - Check timestamp (to ensure object has not been modified by another user).
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateBreak

          CfgValidationHolder validateBreak(CfgBreak Break)

      Validates `CfgBreak` object
      Parameters:
        `Break` - `CfgBreak` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getBreak

          CfgBreakHolder getBreak(CfgBreakFilter breakFilter,
                                CfgSortMode sortMode,
                                CfgBreakDetails details)

      Retrieves Break objects for given filter
      Parameters:
        `breakFilter` - `CfgBreakFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.Break`
        `details` - `CfgBreakDetails`
      Returns:
        returns `CfgBreakHolder`

    - #### insertTaskSequence

          CfgValidationHolder insertTaskSequence(CfgTaskSequence taskSequence,
                                               boolean ignoreWarnings)

      Inserts `CfgTaskSequence` object
      Parameters:
        `taskSequence` - `CfgTaskSequence` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateTaskSequence

          CfgValidationHolder updateTaskSequence(CfgTaskSequence taskSequence,
                                               boolean checkTimestamp,
                                               boolean ignoreWarnings)

      Updates `CfgTaskSequence` object
      Parameters:
        `taskSequence` - `CfgTaskSequence` object to update
        `checkTimestamp` - Check timestamp (to ensure object has not been modified by another user).
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateTaskSequence

          CfgValidationHolder validateTaskSequence(CfgTaskSequence taskSequence)

      Validates `CfgTaskSequence` object
      Parameters:
        `taskSequence` - `CfgTaskSequence` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getTaskSequence

          CfgTaskSequenceHolder getTaskSequence(CfgTaskSequenceFilter taskSequenceFilter,
                                              CfgSortMode sortMode,
                                              CfgTaskSequenceDetails details)

      Retrieves Task Sequence objects for given filter
      Parameters:
        `taskSequenceFilter` - `CfgTaskSequenceFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.TaskSequence`
        `details` - `CfgTaskSequenceDetails`
      Returns:
        returns `CfgTaskSequenceHolder`

    - #### insertExceptionType

          CfgValidationHolder insertExceptionType(CfgExceptionType exceptionType,
                                                boolean ignoreWarnings)

      Inserts `CfgExceptionType` object
      Parameters:
        `exceptionType` - `CfgExceptionType` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateExceptionType

          CfgValidationHolder updateExceptionType(CfgExceptionType exceptionType,
                                                boolean checkTimestamp,
                                                boolean ignoreWarnings)

      Updates `CfgExceptionType` object
      Parameters:
        `exceptionType` - `CfgExceptionType` object to update
        `checkTimestamp` - Check timestamp (to ensure object has not been modified by another user).
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateExceptionType

          CfgValidationHolder validateExceptionType(CfgExceptionType exceptionType)

      Validates `CfgExceptionType` object
      Parameters:
        `exceptionType` - `CfgExceptionType` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getExceptionType

          CfgExceptionTypeHolder getExceptionType(CfgExceptionTypeFilter exceptionTypeFilter,
                                                CfgAgentFilter agentFilter,
                                                CfgSortMode sortMode,
                                                CfgExceptionTypeDetails details)

      Retrieves Exception Type objects for given filters
      Parameters:
        `exceptionTypeFilter` - `CfgExceptionTypeFilter`
        `agentFilter` - `CfgAgentFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.ExceptionType`
        `details` - `CfgExceptionTypeDetails`
      Returns:
        returns `CfgExceptionTypeHolder`

    - #### insertTimeOffType

          CfgValidationHolder insertTimeOffType(CfgTimeOffType timeOffType,
                                              boolean ignoreWarnings)

      Inserts `CfgTimeOffType` object
      Parameters:
        `timeOffType` - `CfgTimeOffType` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateTimeOffType

          CfgValidationHolder updateTimeOffType(CfgTimeOffType timeOffType,
                                              boolean checkTimestamp,
                                              boolean ignoreWarnings)

      Updates `CfgTimeOffType` object
      Parameters:
        `timeOffType` - `CfgTimeOffType` object
        `checkTimestamp` - Check timestamp (to ensure object has not been modified by another user).
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateTimeOffType

          CfgValidationHolder validateTimeOffType(CfgTimeOffType timeOffType)

      Validates `CfgTimeOffType` object
      Parameters:
        `timeOffType` - `CfgTimeOffType` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getTimeOffType

          CfgTimeOffTypeHolder getTimeOffType(CfgTimeOffTypeFilter timeOffTypeFilter,
                                            CfgAgentFilter agentFilter,
                                            CfgSortMode sortMode,
                                            CfgTimeOffTypeDetails details)

      Retrieves TimeOff Type objects for given filters
      Parameters:
        `timeOffTypeFilter` - `CfgTimeOffTypeFilter`
        `agentFilter` - `CfgAgentFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.TimeOffType`
        `details` - `CfgTimeOffTypeDetails`
      Returns:
        returns `CfgTimeOffTypeHolder`

    - #### insertMarkedTime

          CfgValidationHolder insertMarkedTime(CfgMarkedTime markedTime,
                                             boolean ignoreWarnings)

      Inserts `CfgMarkedTime` object
      Parameters:
        `markedTime` - `CfgMarkedTime` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateMarkedTime

          CfgValidationHolder updateMarkedTime(CfgMarkedTime markedTime,
                                             boolean checkTimestamp,
                                             boolean ignoreWarnings)

      Updates `CfgMarkedTime` object
      Parameters:
        `markedTime` - `CfgMarkedTime` object to update
        `checkTimestamp` - Check timestamp (to ensure object has not been modified by another user).
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateMarkedTime

          CfgValidationHolder validateMarkedTime(CfgMarkedTime markedTime)

      Validates `CfgMarkedTime` object
      Parameters:
        `markedTime` - `CfgMarkedTime` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getMarkedTime

          CfgMarkedTimeHolder getMarkedTime(CfgMarkedTimeFilter markedTimeFilter,
                                          CfgAgentFilter agentFilter,
                                          CfgSortMode sortMode,
                                          CfgMarkedTimeDetails details)

      Retrieves Marked Time objects for given filter
      Parameters:
        `markedTimeFilter` - `CfgMarkedTimeFilter`
        `agentFilter` - `CfgAgentFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.MarkedTime`
        `details` - `CfgMarkedTimeDetails`
      Returns:
        returns `CfgMarkedTimeHolder`

    - #### insertMeeting

          CfgValidationHolder insertMeeting(CfgMeeting meeting,
                                          boolean ignoreWarnings)

      Inserts `CfgMeeting` object
      Parameters:
        `meeting` - `CfgMeeting` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateMeeting

          CfgValidationHolder updateMeeting(CfgMeeting meeting,
                                          boolean checkTimestamp,
                                          boolean ignoreWarnings)

      Updates `CfgMeeting` object
      Parameters:
        `meeting` - `CfgMeeting` object to update
        `checkTimestamp` - Check timestamp (to ensure object has not been modified by another user).
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateMeeting

          CfgValidationHolder validateMeeting(CfgMeeting meeting)

      Validates `CfgMeeting` object
      Parameters:
        `meeting` - `CfgMeeting` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getMeeting

          CfgMeetingHolder getMeeting(CfgMeetingFilter meetingFilter,
                                    CfgAgentFilter agentFilter,
                                    CfgSortMode sortMode,
                                    CfgMeetingDetails details)

      Retrieves Meeting objects for given filters
      Parameters:
        `meetingFilter` - `CfgMeetingFilter`
        `agentFilter` - `CfgAgentFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.Meeting`
        `details` - `CfgMeetingDetails`
      Returns:
        returns `CfgMeetingHolder`

    - #### openMeetingSnapshot

          CfgSnapshot openMeetingSnapshot(CfgMeetingFilter meetingFilter,
                                        CfgAgentFilter agentFilter,
                                        CfgSortMode sortMode)

      Opens Meeting object snapshot for given filters
      Parameters:
        `meetingFilter` - `CfgMeetingFilter`
        `agentFilter` - `CfgAgentFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.Meeting`
      Returns:
        returns `CfgSnapshot`

    - #### fetchMeetingFromSnapshot

          CfgMeetingHolder fetchMeetingFromSnapshot(java.lang.String snapshotID,
                                                  int firstIndex,
                                                  int lastIndex,
                                                  CfgMeetingDetails details)

      Retrieves range of objects from Meeting snapshot
      Parameters:
        `snapshotID` - Meeting snapshot ID
        `firstIndex` - First Index
        `lastIndex` - Last Index
        `details` - `CfgMeetingDetails`
      Returns:
        returns `CfgMeetingHolder`

    - #### getAgentState

          java.util.List<CfgAgentState> getAgentState(java.util.List<java.lang.Integer> agentStateIDArray,
                                                    CfgSortMode sortMode)

      Retrieves Genesys Agent States (`CfgAgentState`)
      Parameters:
        `agentStateIDArray` - Agent State ID filter. Use "null" to retrieve all.
        `sortMode` - `CfgSortMode`, `ECfgSortMode.AgentState`
      Returns:
        returns `List`<`CfgAgentState`>

    - #### getFixedState

          java.util.List<CfgFixedState> getFixedState(java.util.List<java.lang.Integer> fixedStateIDArray,
                                                    CfgSortMode sortMode)

      Parameters:
        `sortMode` -
        `fixedStateIDArray` -
      Returns:
        returns `List`<{CfgFixedState}>

    - #### insertState

          CfgValidationHolder insertState(CfgState state,
                                        boolean ignoreWarnings)

      Parameters:
        `state` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### updateState

          CfgValidationHolder updateState(CfgState state,
                                        boolean checkTimestamp,
                                        boolean ignoreWarnings)

      Parameters:
        `state` -
        `checkTimestamp` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### validateState

          CfgValidationHolder validateState(CfgState state)

      Parameters:
        `state` -
      Returns:
        returns `CfgValidationHolder`

    - #### getState

          CfgStateHolder getState(CfgStateFilter stateFilter,
                                CfgSortMode sortMode,
                                CfgStateDetails details)

      Parameters:
        `stateFilter` -
        `sortMode` -
        `details` -
      Returns:
        returns `CfgStateHolder`

    - #### insertStateGroup

          CfgValidationHolder insertStateGroup(CfgStateGroup stateGroup,
                                             boolean ignoreWarnings)

      Parameters:
        `stateGroup` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### updateStateGroup

          CfgValidationHolder updateStateGroup(CfgStateGroup stateGroup,
                                             boolean checkTimestamp,
                                             boolean ignoreWarnings)

      Parameters:
        `checkTimestamp` -
        `stateGroup` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### validateStateGroup

          CfgValidationHolder validateStateGroup(CfgStateGroup stateGroup)

      Parameters:
        `stateGroup` -
      Returns:
        returns `CfgValidationHolder`

    - #### getStateGroup

          CfgStateGroupHolder getStateGroup(CfgStateGroupFilter stateGroupFilter,
                                          CfgSortMode sortMode,
                                          CfgStateGroupDetails details)

      Parameters:
        `sortMode` -
        `stateGroupFilter` -
        `details` -
      Returns:
        returns `CfgStateGroupHolder`

    - #### insertSkill

          CfgValidationHolder insertSkill(CfgSkill skill,
                                        boolean ignoreWarnings)

      Inserts `CfgSkill` object
      Parameters:
        `skill` - `CfgSkill` object to insert
        `ignoreWarnings` -
      Returns:
        `CfgValidationHolder`

    - #### updateSkill

          CfgValidationHolder updateSkill(CfgSkill skill,
                                        boolean checkTimestamp,
                                        boolean ignoreWarnings)

      Updates `CfgSkill` object
      Parameters:
        `skill` - `CfgSkill` object to update
        `checkTimestamp` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### validateSkill

          CfgValidationHolder validateSkill(CfgSkill skill)

      Validates `CfgSkill` object
      Parameters:
        `skill` - `CfgSkill` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getSkill

          java.util.List<CfgSkill> getSkill(java.util.List<java.lang.Integer> skillIDArray,
                                          CfgSortMode sortMode)

      Retrieves Skill information (`CfgSkill`)
      Parameters:
        `skillIDArray` - Skill ID filter. Use "null" to retrieve all.
        `sortMode` - `CfgSortMode`, `ECfgSortMode.Skill`
      Returns:
        returns `List`<`CfgSkill`>

    - #### getSubsystem

          java.util.List<CfgSubsystem> getSubsystem(CfgSortMode sortMode)

      Returns Subsystem objects
      Parameters:
        `sortMode` -
      Returns:
        returns `List`<`CfgSubsystem`>

    - #### insertUser

          CfgValidationHolder insertUser(CfgUser user,
                                       boolean ignoreWarnings)

      Inserts User object
      Parameters:
        `user` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### updateUser

          CfgValidationHolder updateUser(CfgUser user,
                                       boolean checkTimestamp,
                                       boolean ignoreWarnings)

      Updates User object
      Parameters:
        `user` -
        `checkTimestamp` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### validateUser

          CfgValidationHolder validateUser(CfgUser user)

      Validates User object
      Parameters:
        `user` -
      Returns:
        returns `CfgValidationHolder`

    - #### getUser

          CfgUserHolder getUser(java.util.List<java.lang.Integer> userIDArray,
                              int sortMode,
                              boolean ascending,
                              int infoType,
                              boolean provideBUInfo,
                              boolean provideSiteInfo,
                              boolean provideTeamInfo,
                              boolean provideSubsystemInfo)

      Returns User information
      Parameters:
        `provideSiteInfo` -
        `provideTeamInfo` -
        `sortMode` -
        `userIDArray` -
        `provideBUInfo` -
        `provideSubsystemInfo` -
        `ascending` -
        `infoType` -
      Returns:
        returns `CfgUserHolder`

    - #### insertTimezone

          CfgValidationHolder insertTimezone(CfgTimezone timezone,
                                           boolean ignoreWarnings)

      Inserts Time Zone
      Parameters:
        `timezone` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### updateTimezone

          CfgValidationHolder updateTimezone(CfgTimezone timezone,
                                           boolean checkTimestamp,
                                           boolean ignoreWarnings)

      Updates Time Zone
      Parameters:
        `checkTimestamp` -
        `timezone` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### validateTimezone

          CfgValidationHolder validateTimezone(CfgTimezone timezone)

      Validates Time Zone object
      Parameters:
        `timezone` -
      Returns:
        returns `CfgValidationHolder`

    - #### getTimezone

          CfgTimezoneHolder getTimezone(java.util.List<java.lang.Integer> timezoneIDArray,
                                      int sortMode,
                                      boolean ascending,
                                      int infoType)

      Retrieves Time Zone information (`CfgTimezone` or `CfgTimezoneShort`)
      Parameters:
        `timezoneIDArray` - Time Zone ID filter. Use "null" to retrieve all.
        `sortMode` - Sort Mode (`ECfgSortMode.Timezone`)
        `ascending` - Sort Order ("true" - ascending, "false" - descending)
        `infoType` - Requested details level (`ECfgInfoType`)
      Returns:
        returns `CfgTimezoneHolder`

    - #### convertLocalTime

          double convertLocalTime(int timezoneID1,
                                double localTime1,
                                int timezoneID2)

      Converts time in one time zone to another timezone
      Parameters:
        `timezoneID1` -
        `localTime1` -
        `timezoneID2` -
      Returns:
        returns double

    - #### convertLocalTime2GMT

          double convertLocalTime2GMT(int timezoneID,
                                    double localTime)

      Parameters:
        `timezoneID` -
        `localTime` -
      Returns:
        returns double

    - #### convertGMT2LocalTime

          double convertGMT2LocalTime(double GMTTime,
                                    int timezoneID)

      Parameters:
        `GMTTime` -
        `timezoneID` -
      Returns:
        returns double

    - #### setLocalTimezone

          void setLocalTimezone(CfgTimezone timezone)

      Assigns Local Time Zone to current session
      Parameters:
        `timezone` -

    - #### insertRotation

          CfgValidationHolder insertRotation(CfgRotation rotation,
                                           boolean ignoreWarnings)

      Inserts Rotating Pattern
      Parameters:
        `rotation` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### updateRotation

          CfgValidationHolder updateRotation(CfgRotation rotation,
                                           boolean checkTimestamp,
                                           boolean ignoreWarnings)

      Updates Rotating Pattern
      Parameters:
        `checkTimestamp` -
        `rotation` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### validateRotation

          CfgValidationHolder validateRotation(CfgRotation rotation)

      Validates Rotating Pattern
      Parameters:
        `rotation` -
      Returns:
        returns `CfgValidationHolder`

    - #### getRotation

          CfgRotationHolder getRotation(CfgRotationFilter rotationFilter,
                                      CfgAgentFilter agentFilter,
                                      CfgSortMode sortMode,
                                      CfgRotationDetails details)

      Retrieves Rotating Pattern information (`CfgRotation` or `CfgRotationShort`) for the given Site
      Parameters:
        `rotationFilter` - `CfgRotationFilter`
        `agentFilter` - `CfgAgentFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.Rotation`
        `details` - `CfgRotationDetails`
      Returns:
        returns `CfgRotationHolder`

    - #### openRotationSnapshot

          CfgSnapshot openRotationSnapshot(CfgRotationFilter rotationFilter,
                                         CfgAgentFilter agentFilter,
                                         CfgSortMode sortMode)

      Opens Rotating Pattern object snapshot for given filters
      Parameters:
        `rotationFilter` - `CfgRotationFilter`
        `agentFilter` - `CfgAgentFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.Rotation`
      Returns:
        returns `CfgSnapshot`

    - #### fetchRotationFromSnapshot

          CfgRotationHolder fetchRotationFromSnapshot(java.lang.String snapshotID,
                                                    int firstIndex,
                                                    int lastIndex,
                                                    CfgRotationDetails details)

      Retrieves a range of Rotating Pattern objects from snapshot
      Parameters:
        `snapshotID` - Rotating Pattern object snapshot ID
        `firstIndex` -
        `lastIndex` -
        `details` - `CfgRotationDetails`
      Returns:
        returns `CfgRotationHolder`

    - #### getGlobalSettings

          CfgGlobalSettings getGlobalSettings()

      Returns Global Settings
      Returns:
        returns `CfgGlobalSettings`

    - #### setGlobalSettings

          void setGlobalSettings(CfgGlobalSettings settings)

      Sets Global Settings
      Parameters:
        `settings` - `CfgGlobalSettings`

    - #### insertAccrualRule

          CfgValidationHolder insertAccrualRule(CfgAccrualRule accrualRule,
                                              boolean ignoreWarnings)

      Parameters:
        `accrualRule` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### updateAccrualRule

          CfgValidationHolder updateAccrualRule(CfgAccrualRule accrualRule,
                                              boolean checkTimestamp,
                                              boolean ignoreWarnings)

      Parameters:
        `checkTimestamp` -
        `accrualRule` -
        `ignoreWarnings` -
      Returns:
        returns `CfgValidationHolder`

    - #### validateAccrualRule

          CfgValidationHolder validateAccrualRule(CfgAccrualRule accrualRule)

      Parameters:
        `accrualRule` -
      Returns:
        returns `CfgValidationHolder`

    - #### getAccrualRule

          CfgAccrualRuleHolder getAccrualRule(CfgAccrualRuleFilter accrualRuleFilter,
                                            CfgAgentFilter agentFilter,
                                            CfgSortMode sortMode,
                                            CfgAccrualRuleDetails details)

      Parameters:
        `agentFilter` -
        `sortMode` -
        `details` -
        `accrualRuleFilter` -
      Returns:
        returns `CfgAccrualRuleHolder`

    - #### getPlanningPeriod

          CfgPlanningPeriodHolder getPlanningPeriod(int siteID,
                                                  double startDate,
                                                  double endDate)

      Returns Planning Period information
      Parameters:
        `siteID` -
        `startDate` -
        `endDate` -
      Returns:
        returns `CfgPlanningPeriodHolder`

    - #### insertNotifyParam

          CfgValidationHolder insertNotifyParam(CfgNotifyParam notifyParam,
                                              boolean ignoreWarnings)

      Inserts new `CfgNotifyParam` object into database
      Parameters:
        `notifyParam` - `CfgNotifyParam` to insert
        `ignoreWarnings` - Ignore warnings, if any (true/false)
      Returns:
        `CfgValidationHolder`

    - #### insertNotifyParams

          CfgValidationHolder insertNotifyParams(java.util.List<CfgNotifyParam> notifyParams,
                                               boolean ignoreWarnings)

      Inserts multiple `CfgNotifyParam` objects into database.
      Parameters:
        `notifyParams` - An array of `CfgNotifyParam` objects. if wmNotifyParamId == 0 -- A new object is inserted if wmNotifyParamId > 0 -- An object designated by wmNotifyParamId is updated if wmNotifyParamId < 0 -- An object designated by abs(wmNotifyParamId) is deleted
        `ignoreWarnings` - Ignore warnings if any (true/false)
      Returns:
        `CfgValidationHolder`

    - #### updateNotifyParam

          CfgValidationHolder updateNotifyParam(CfgNotifyParam notifyParam,
                                              boolean checkTimestamp,
                                              boolean ignoreWarnings)

      Updates an existing `CfgNotifyParam` object in database
      Parameters:
        `notifyParam` - The object to be updated
        `checkTimestamp` - Check timestamp (to ensure that the object has not been modified by another user)
        `ignoreWarnings` - Ignore warnings, if any (true/false)
      Returns:
        `CfgValidationHolder`

    - #### updateNotifyParams

          CfgValidationHolder updateNotifyParams(java.util.List<CfgNotifyParam> notifyParams,
                                               boolean checkTimestamp,
                                               boolean ignoreWarnings)

      Updates multiple `CfgNotifyParam` objects in the database.
      Parameters:
        `notifyParams` - An array of `CfgNotifyParam` objects. if wmNotifyParamId > 0 -- An object designated by wmNotifyParamId has been updated if wmNotifyParamId == 0 -- A new object has been inserted if wmNotifyParamId < 0 -- An object designated by abs(wmNotifyParamId) has been deleted
        `checkTimestamp` - Check timestamp (to ensure that the object has not been modified by another user)
        `ignoreWarnings` - Ignore warnings, if any (true/false)
      Returns:
        `CfgValidationHolder`

    - #### validateNotifyParam

          CfgValidationHolder validateNotifyParam(CfgNotifyParam notifyParam)

      Validates `CfgNotifyParam` object
      Parameters:
        `notifyParam` - `CfgNotifyParam` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getNotifyParam

          java.util.List<CfgNotifyParam> getNotifyParam(int siteID,
                                                      java.util.List<java.lang.Integer> notifyParamIDArray)

      Returns `CfgNotifyParam` object(s)
      Parameters:
        `siteID` - Site ID (can be zero, designating "general" notification parameters, and can be -1, if requesting all objects)
        `notifyParamIDArray` - An array of wmNotifyParamId values. Can be null, meaning all objects.
      Returns:
        returns `List`<`CfgNotifyParam`>

    - #### getNotifyParamBySubsystem

          java.util.List<CfgNotifyParam> getNotifyParamBySubsystem(int siteID,
                                                                 java.util.List<java.lang.Integer> subsystemGroupIDArray)

      Returns Notify Params by Subsystem
      Parameters:
        `subsystemGroupIDArray` -
        `siteID` -
      Returns:
        returns `List`<`CfgNotifyParam`>

    - #### getColors

          CfgColors getColors()

      Returns Colors
      Returns:
        returns `CfgColors`

    - #### setColors

          void setColors(CfgColors colors)

      Sets Colors
      Parameters:
        `colors` - `CfgColors`

    - #### insertReportTask

          CfgValidationHolder insertReportTask(CfgReportTask reportTask,
                                             boolean ignoreWarnings)

      Inserts new `CfgReportTask` object.
      Parameters:
        `reportTask` - `CfgReportTask`
        `ignoreWarnings` - Ignore warnings if any or not
      Returns:
        `CfgValidationHolder`

    - #### updateReportTask

          CfgValidationHolder updateReportTask(CfgReportTask reportTask,
                                             boolean checkTimestamp,
                                             boolean ignoreWarnings)

      Updates existing `CfgReportTask` object.
      Parameters:
        `reportTask` - `CfgReportTask`
        `checkTimestamp` - Check timestamp to make sure that object wasn't modified by another user
        `ignoreWarnings` - Ignore warnings if any or not
      Returns:
        `CfgValidationHolder`

    - #### getReportTask

          CfgReportTaskHolder getReportTask(CfgReportTaskFilter filter,
                                          CfgSortMode sortMode,
                                          CfgReportTaskDetails details)

      Returns Report Task objects
      Parameters:
        `filter` - `CfgReportTaskFilter`
        `sortMode` - `CfgSortMode`
        `details` - `CfgReportTaskDetails`
      Returns:
        `CfgReportTaskHolder`

    - #### openReportTaskSnapshot

          CfgSnapshot openReportTaskSnapshot(CfgReportTaskFilter filter,
                                           CfgSortMode sortMode)

      Opens a snapshot of Report Task info on server based on provided filter
      Parameters:
        `filter` - `CfgReportTaskFilter`
        `sortMode` - `CfgSortMode`
      Returns:
        `CfgSnapshot`

    - #### fetchReportTaskFromSnapshot

          CfgReportTaskHolder fetchReportTaskFromSnapshot(java.lang.String snapshotID,
                                                        int firstIndex,
                                                        int lastIndex,
                                                        CfgReportTaskDetails details)

      Retrieves a portion of Report Task data from snapshot earlier created with `openReportTaskSnapshot` method.
      Parameters:
        `snapshotID` - Report Task Snapshot ID
        `firstIndex` - First object index
        `lastIndex` - Last object index
        `details` - `CfgReportTaskDetails`
      Returns:
        `CfgReportTaskHolder`

    - #### insertReport

          CfgValidationHolder insertReport(CfgReport report,
                                         boolean ignoreWarnings)

      Inserts new `CfgReport` object.
      Parameters:
        `report` - `CfgReport`
        `ignoreWarnings` - Ignore warnings if any or not
      Returns:
        `CfgValidationHolder`

    - #### updateReport

          CfgValidationHolder updateReport(CfgReport report,
                                         boolean checkTimestamp,
                                         boolean ignoreWarnings)

      Updates existing `CfgReport` object.
      Parameters:
        `report` - `CfgReport`
        `checkTimestamp` - Check timestamp to make sure that object wasn't modified by another user
        `ignoreWarnings` - Ignore warnings if any or not
      Returns:
        `CfgValidationHolder`

    - #### getReport

          CfgReportHolder getReport(CfgReportFilter filter,
                                  CfgSortMode sortMode,
                                  CfgReportDetails details)

      Returns Report Task objects based on specified filter
      Parameters:
        `filter` - `CfgReportFilter`
        `sortMode` - `CfgSortMode`
        `details` - `CfgReportDetails`
      Returns:
        `CfgReportHolder`

    - #### openReportSnapshot

          CfgSnapshot openReportSnapshot(CfgReportFilter filter,
                                       CfgSortMode sortMode)

      Opens a snapshot of Report objects on server based on filter.
      Parameters:
        `filter` - `CfgReportFilter`
        `sortMode` - `CfgSortMode`
      Returns:
        `CfgSnapshot`

    - #### fetchReportFromSnapshot

          CfgReportHolder fetchReportFromSnapshot(java.lang.String snapshotID,
                                                int firstIndex,
                                                int lastIndex,
                                                CfgReportDetails details)

      Retrieves a portion of Report Task data from snapshot earlier created with `openReportSnapshot` method.
      Parameters:
        `snapshotID` - Report snapshot ID
        `firstIndex` - First object index
        `lastIndex` - Last object index
        `details` - `CfgReportDetails`
      Returns:
        `CfgReportHolder`

    - #### insertSecurityRole

          CfgValidationHolder insertSecurityRole(CfgSecurityRole securityRole,
                                               boolean ignoreWarnings)

      Inserts new Security Role
      Parameters:
        `ignoreWarnings` -
        `securityRole` -
      Returns:
        returns `CfgValidationHolder`

    - #### updateSecurityRole

          CfgValidationHolder updateSecurityRole(CfgSecurityRole securityRole,
                                               boolean checkTimestamp,
                                               boolean ignoreWarnings)

      Updates Security Role
      Parameters:
        `checkTimestamp` -
        `ignoreWarnings` -
        `securityRole` -
      Returns:
        returns `CfgValidationHolder`

    - #### getSecurityRole

          CfgSecurityRoleHolder getSecurityRole(java.util.List<java.lang.Integer> wmSecurityRoleId,
                                              CfgSortMode sortMode,
                                              CfgSecurityRoleDetails details)

      Returns Security Roles
      Parameters:
        `sortMode` -
        `details` -
        `wmSecurityRoleId` -
      Returns:
        returns0 `CfgSecurityRoleHolder`

    - #### getAuditLogAsync

          java.lang.String getAuditLogAsync(CfgAuditFilter auditFilter,
                                          CfgSortMode sortMode)

      Reads (async) Configuration Audit Log for specified filter
      Parameters:
        `auditFilter` - `CfgAuditFilter`
        `sortMode` - `CfgSortMode`
      Returns:
        returns Async Request ID

    - #### getAuditLogResults

          CfgAuditLog getAuditLogResults(java.lang.String requestID)

      Returns Audit Log for completed Async Request
      Parameters:
        `requestID` - Async Request ID
      Returns:
        returns `CfgAuditLog`

    - #### getTeamHistory

          java.util.List<CfgTeamHistory> getTeamHistory(CfgTeamFilter teamFilter,
                                                      double startDateTime,
                                                      double endDateTime,
                                                      int timezoneID)

      Returns Team History
      Parameters:
        `teamFilter` - `CfgTeamFilter`
        `startDateTime` -
        `endDateTime` -
        `timezoneID` -
      Returns:
        returns `List`<`CfgTeamHistory`>

    - #### getAgentTeamHistory

          java.util.List<CfgAgentTeamHistory> getAgentTeamHistory(CfgAgentFilter agentFilter,
                                                                double startDateTime,
                                                                double endDateTime,
                                                                int timezoneID)

      Returns Agent Team History
      Parameters:
        `agentFilter` - `CfgAgentFilter`
        `startDateTime` -
        `endDateTime` -
        `timezoneID` -
      Returns:
        returns `List`<`CfgAgentTeamHistory`>

    - #### insertCarpool

          CfgValidationHolder insertCarpool(CfgCarpool carpool,
                                          boolean ignoreWarnings)

      Inserts new `CfgCarpool` object
      Parameters:
        `carpool` - `CfgCarpool` object to insert
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### updateCarpool

          CfgValidationHolder updateCarpool(CfgCarpool carpool,
                                          boolean checkTimestamp,
                                          boolean ignoreWarnings)

      Updates existing `CfgCarpool` object
      Parameters:
        `carpool` - `CfgCarpool` object to update
        `checkTimestamp` - Check timestamp to make sure that object wasn't modified by another user
        `ignoreWarnings` - Ignore any warnings or not
      Returns:
        returns `CfgValidationHolder`

    - #### validateCarpool

          CfgValidationHolder validateCarpool(CfgCarpool carpool)

      Validate `CfgCarpool` object
      Parameters:
        `carpool` - `CfgCarpool` object to validate
      Returns:
        returns `CfgValidationHolder`

    - #### getCarpool

          CfgCarpoolHolder getCarpool(CfgCarpoolFilter carpoolFilter,
                                    CfgAgentFilter agentFilter,
                                    CfgSortMode sortMode,
                                    CfgCarpoolDetails details)

      Returns Carpool objects for specified filters
      Parameters:
        `carpoolFilter` - `CfgCarpoolFilter`
        `agentFilter` - `CfgAgentFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.Carpool`
        `details` - `CfgCarpoolDetails`
      Returns:
        returns `CfgCarpoolHolder`

    - #### openCarpoolSnapshot

          CfgSnapshot openCarpoolSnapshot(CfgCarpoolFilter carpoolFilter,
                                        CfgAgentFilter agentFilter,
                                        CfgSortMode sortMode)

      Opens Carpool object snapshot for specified filters
      Parameters:
        `carpoolFilter` - `CfgCarpoolFilter`
        `agentFilter` - `CfgAgentFilter`
        `sortMode` - `CfgSortMode`, `ECfgSortMode.Carpool`
      Returns:
        returns `CfgSnapshot`

    - #### fetchCarpoolFromSnapshot

          CfgCarpoolHolder fetchCarpoolFromSnapshot(java.lang.String snapshotID,
                                                  int firstIndex,
                                                  int lastIndex,
                                                  CfgCarpoolDetails details)

      Returns a range of Carpool objects from the snapshot
      Parameters:
        `snapshotID` - Carpool snapshot ID
        `firstIndex` - First index
        `lastIndex` - Last index
        `details` - `CfgCarpoolDetails`
      Returns:
        returns `CfgCarpoolHolder`

Copyright © 2005-2016 Genesys Telecommunications Labs, Inc. All Rights Reserved.